Index: trunk/MagicSoft/Simulation/Corsika/GuiSimone/MainFrameSimone.cxx
===================================================================
--- trunk/MagicSoft/Simulation/Corsika/GuiSimone/MainFrameSimone.cxx	(revision 416)
+++ trunk/MagicSoft/Simulation/Corsika/GuiSimone/MainFrameSimone.cxx	(revision 423)
@@ -19,5 +19,5 @@
   
   fNtup = new TNtuple ("fNtup", "Ntuple with Run distributions", 
-		       "PartID:Energy:CoreX:CoreY") ; 
+		       "PartID:Energy:CoreX:CoreY:Theta:Phi:FirstInt") ; 
   //
   // Create a main frame with a number of different buttons.
@@ -37,9 +37,9 @@
   fFileMenu->AddEntry ("Exit", M_FILE_EXIT ) ; 
 
+
   //
   //  the button messages are handled by main frame (this) 
   //
   fFileMenu->Associate(this) ; 
-
 
   fMenuBar = new TGMenuBar ( this, 1, 1, kHorizontalFrame ) ; 
@@ -164,7 +164,7 @@
 		     new TGLayoutHints(kLHintsTop | kLHintsLeft, 5, 5, 5, 5 ) ) ;
 
-  fButtonPlot = new TGTextButton(fTabF2a, "PLOT", M_BUTTON_PLOT );
-  fButtonPlot->Associate(this) ;   
-  fTabF2a->AddFrame (fButtonPlot, new TGLayoutHints(kLHintsTop | kLHintsLeft, 50, 50, 5, 5) );
+  fButtonPrint = new TGTextButton(fTabF2a, "Print", M_BUTTON_PRINT );
+  fButtonPrint->Associate(this) ;   
+  fTabF2a->AddFrame (fButtonPrint, new TGLayoutHints(kLHintsTop | kLHintsLeft, 50, 50, 5, 5) );
 
   //  create the entries in the second subframe
@@ -173,5 +173,5 @@
   fTabF2b->AddFrame(fCanvasRun, new TGLayoutHints(kLHintsTop | kLHintsLeft | kLHintsExpandY | kLHintsExpandX, 5, 5, 5, 5 ) ) ; 
 
-  //  create the entries in the second subframe
+  //  create the entries in the third subframe
 
   fButtonPartID = new TGTextButton(fTabF2c, "PartId", M_BUTTON_PARTID );
@@ -183,19 +183,110 @@
   fTabF2c->AddFrame (fButtonEnergy, new TGLayoutHints(kLHintsBottom | kLHintsLeft, 2, 2, 2, 2) );
 
-  fButtonCore = new TGTextButton(fTabF2c, "CoreX", M_BUTTON_CORE );
+  fButtonCore = new TGTextButton(fTabF2c, "Core", M_BUTTON_CORE );
   fButtonCore->Associate(this) ;
   fTabF2c->AddFrame (fButtonCore, new TGLayoutHints(kLHintsBottom | kLHintsLeft, 2, 2, 2, 2) );
-
+ 
+  fButtonTheta = new TGTextButton(fTabF2c, "Theta", M_BUTTON_THETA );
+  fButtonTheta->Associate(this) ;
+  fTabF2c->AddFrame (fButtonTheta, new TGLayoutHints(kLHintsBottom | kLHintsLeft, 2, 2, 2, 2) );
+
+  fButtonPhi = new TGTextButton(fTabF2c, " Phi ", M_BUTTON_PHI );
+  fButtonPhi->Associate(this) ;
+  fTabF2c->AddFrame (fButtonPhi, new TGLayoutHints(kLHintsBottom | kLHintsLeft, 2, 2, 2, 2) );
+
+  fButtonFirst = new TGTextButton(fTabF2c, "FirstInt", M_BUTTON_FIRSTINT );
+  fButtonFirst->Associate(this) ;
+  fTabF2c->AddFrame (fButtonFirst, new TGLayoutHints(kLHintsBottom | kLHintsLeft, 2, 2, 2, 2) );
+ 
   //
   //  create Tab 3 
   //
 
+  tf = fTab->AddTab("Event Dist") ; 
+  fTabF3 = new TGCompositeFrame (tf, 100, 100, kVerticalFrame) ; 
+   
+  tf->AddFrame(fTabF3, fLayTab) ; 
+
+
+  //  create the vertical subframes
+
+  fTabF3a = new TGCompositeFrame (fTabF3, 100, 100, kHorizontalFrame) ; 
+  fTabF3->AddFrame(fTabF3a, fLayTab ) ; 
+  
+  fTabF3b = new TGCompositeFrame (fTabF3, 300, 300, kHorizontalFrame) ; 
+  fTabF3->AddFrame(fTabF3b, 
+		   new TGLayoutHints(kLHintsTop | kLHintsLeft | kLHintsExpandX |kLHintsExpandY, 5, 5, 5, 5 ) ) ; 
+
+  fTabF3c = new TGCompositeFrame (fTabF3, 100, 100, kHorizontalFrame) ; 
+  fTabF3->AddFrame(fTabF3c,new TGLayoutHints(kLHintsBottom | kLHintsLeft | kLHintsExpandX, 5, 5, 5, 5 )  ) ; 
+
+  //  create the entries in first subframe
+  
+  fLabel3 = new TGLabel(fTabF3a, new TGString("Input:") );       
+  fTabF3a->AddFrame( fLabel3, new TGLayoutHints(kLHintsTop | kLHintsLeft , 5, 5, 5, 5 ) ) ;   
+
+  fDir3 = new TGListBox(fTabF3a, -1) ; 
+  fDir3->Resize(350,20) ; 
+  sprintf ( temp, "%s", fInputPath ) ; 
+  fDir3->AddEntry(temp, 1) ; 
+  fTabF3a->AddFrame( fDir3, new TGLayoutHints(kLHintsTop | kLHintsLeft | kLHintsExpandX | kLHintsExpandY, 5, 5, 5, 5 ) ) ; 
+  
+  fLabel4 = new TGLabel(fTabF3a, new TGString("EventNb:") );       
+  fTabF3a->AddFrame( fLabel4, new TGLayoutHints(kLHintsTop | kLHintsLeft , 5, 5, 5, 5 ) ) ;   
+  
+  fDirEvtNb = new TGListBox(fTabF3a, -1) ; 
+  fDirEvtNb->Resize(50,20) ; 
+  fTabF3a->AddFrame( fDirEvtNb, 
+		     new TGLayoutHints(kLHintsTop | kLHintsLeft, 5, 5, 5, 5 ) ) ;
+
+  fButtonPrev = new TGTextButton(fTabF3a, "Prev", M_BUTTON_PREV );
+  fButtonPrev->Associate(this) ;   
+  fTabF3a->AddFrame (fButtonPrev, new TGLayoutHints(kLHintsTop | kLHintsLeft, 10, 10, 5, 5) );
+
+  fButtonNext = new TGTextButton(fTabF3a, "Next", M_BUTTON_NEXT );
+  fButtonNext->Associate(this) ;   
+  fTabF3a->AddFrame (fButtonNext, new TGLayoutHints(kLHintsTop | kLHintsLeft, 10, 10, 5, 5) );
+  
+
+  // 
+  //  create the entries in the second subframe
+
+  
+  fCanvasEvt =  new TRootEmbeddedCanvas("fCanvasEvt", fTabF3b, 300, 300 ) ; 
+  fTabF3b->AddFrame(fCanvasEvt, new TGLayoutHints(kLHintsTop | kLHintsLeft | kLHintsExpandY | kLHintsExpandX, 5, 5, 5, 5 ) ) ; 
+
+
+  //  create the entries in the third subframe
+
+  fButtonWave = new TGTextButton(fTabF3c, "Wavelength", M_BUTTON_WAVELEN );
+  fButtonWave->Associate(this) ;
+  fTabF3c->AddFrame (fButtonWave, new TGLayoutHints(kLHintsBottom | kLHintsLeft, 2, 2, 2, 2) );
+
+  fButtonPosit = new TGTextButton(fTabF3c, "Position", M_BUTTON_POSIT );
+  fButtonPosit->Associate(this) ;
+  fTabF3c->AddFrame (fButtonPosit, new TGLayoutHints(kLHintsBottom | kLHintsLeft, 2, 2, 2, 2) );
+
+  fButtonHeight = new TGTextButton(fTabF3c, "Height", M_BUTTON_HEIGHT );
+  fButtonHeight->Associate(this) ;
+  fTabF3c->AddFrame (fButtonHeight, new TGLayoutHints(kLHintsBottom | kLHintsLeft, 2, 2, 2, 2) );
+
+  fButtonTime = new TGTextButton(fTabF3c, "Time", M_BUTTON_TIME );
+  fButtonTime->Associate(this) ;
+  fTabF3c->AddFrame (fButtonTime, new TGLayoutHints(kLHintsBottom | kLHintsLeft, 2, 2, 2, 2) );
+
+  fButtonDire = new TGTextButton(fTabF3c, "Direction", M_BUTTON_DIRE );
+  fButtonDire->Associate(this) ;
+  fTabF3c->AddFrame (fButtonDire, new TGLayoutHints(kLHintsBottom | kLHintsLeft, 2, 2, 2, 2) );
+
+  //
+  //  create Tab 4 
+  //
+
   tf = fTab->AddTab("Control") ; 
-  fTabF3 = new TGCompositeFrame (tf, 100, 100, kVerticalFrame) ; 
-  
-  
-  fButton1 = new TGTextButton(fTabF3, "&Exit", M_CTRL_EXIT);
-  fButton2 = new TGTextButton(fTabF3, "Working Directory", M_CTRL_PWD);
-  fButton3 = new TGTextButton(fTabF3, "Input Path", M_CTRL_PATH);
+  fTabF4 = new TGCompositeFrame (tf, 100, 100, kVerticalFrame) ; 
+    
+  fButton1 = new TGTextButton(fTabF4, "&Exit", M_CTRL_EXIT);
+  fButton2 = new TGTextButton(fTabF4, "Working Directory", M_CTRL_PWD);
+  fButton3 = new TGTextButton(fTabF4, "Input Path", M_CTRL_PATH);
 
   fButton1->Associate(this) ; 
@@ -205,15 +296,13 @@
   fLayout = new TGLayoutHints(kLHintsTop | kLHintsLeft, 10, 10, 10, 10);
   
-  fTabF3->AddFrame (fButton1, fLayout ) ; 
-  fTabF3->AddFrame (fButton2, fLayout ) ; 
-  fTabF3->AddFrame (fButton3, fLayout ) ; 
-  
-  tf->AddFrame(fTabF3, fLayTab) ; 
+  fTabF4->AddFrame (fButton1, fLayout ) ; 
+  fTabF4->AddFrame (fButton2, fLayout ) ; 
+  fTabF4->AddFrame (fButton3, fLayout ) ; 
+  
+  tf->AddFrame(fTabF4, fLayTab) ; 
 
   fFrame->AddFrame ( fTab, new TGLayoutHints(kLHintsBottom | kLHintsExpandX | kLHintsExpandY, 5, 5, 5, 5) ); 
 
   AddFrame(fFrame, new TGLayoutHints (kLHintsExpandX|kLHintsExpandY) ) ; 
-
-
 
   //
@@ -238,5 +327,5 @@
   delete fButton1 ; 
   delete fButton2 ; 
-  delete fFrame, fTab, fTabF1, fTabF2, fTabF3 ; 
+  delete fFrame, fTab, fTabF1, fTabF2, fTabF4 ; 
   delete fTabF1a, fTabF1b ; 
   delete fDir, fCdup, fListMode, fDetail ; 
@@ -294,4 +383,24 @@
 // ======================================================================
 // ======================================================================        
+
+Bool_t MainFrameSimone::DrawRunParam (Char_t *paraName) {
+
+  TCanvas *canvas =  fCanvasRun->GetCanvas();
+  
+  canvas->cd() ; 
+
+  if ( CheckNtup() )  
+    {
+      fNtup->Draw(paraName) ; 
+      canvas->Modified() ; 
+      canvas->Update() ; 
+    }
+  else  
+    printf("No Ntuple exist!!\n"); 
+}
+
+// ======================================================================
+// ======================================================================        
+
 Bool_t MainFrameSimone::CheckNtup()
 {
@@ -320,4 +429,6 @@
 Bool_t MainFrameSimone::ReadDataToNtup()
 {
+  FILE  *unit ; 
+  Char_t  rootfile[256] ; 
   Char_t  cername[256] ; 
   Char_t  datname[256] ;
@@ -328,14 +439,90 @@
   
   printf("readin the input path: %s \n", fInputPath ) ; 
-  
+
   fNtup->Reset() ; 
 
-  for (int i_cer = 1; i_cer <= 100000; i_cer++ ) {
-
-    //   inform about progress
-
-     if (!( i_cer %1000) )
-      {
-	cout << i_cer << endl ; 
+  sprintf (rootfile, "%s/simone.root", fInputPath ) ; 
+
+  //
+  //   check if there is a file simone.root in the directory fInputPath
+  //
+  //   if the file is there open it an read the ntuple in, 
+  //   else open all cerenkov files and fill the histograms and store 
+  //   the ntuple as simone.root in the directory fInputPath
+  //
+
+  if ( ( unit = fopen (rootfile, "r" )) != 0  ) {
+    fclose (unit) ; 
+    
+    //
+    //  open the file as a root file
+    // 
+    
+    TFile *hfile = new TFile ( rootfile ) ; 
+    
+    //
+    //   connect the ntuple from the  file
+    //
+    
+    fNtup = (TNtuple *) hfile->Get("fNtup") ; 
+
+    fNtup->Read("fNtup") ; 
+
+    //
+    //   close the root file
+    //
+
+    //hfile->Close() ; 
+
+    //delete hfile ;
+
+    
+
+    fNumEvents = (Int_t) fNtup->GetEntries()  ;
+	
+    sprintf ( datname, "%d", fNumEvents ) ; 
+	
+    fDirNum->RemoveEntry(1) ; 
+    fDirNum->AddEntry(datname,1) ; 	    
+    fDirNum->MapSubwindows() ; 
+    fDirNum->Layout() ;  
+  }
+  else {
+    //
+    //  create the root file
+    //
+    
+    TFile *hfile = new TFile ( rootfile, "NEW" ) ; 
+
+    
+    for (int i_cer = 1; i_cer <= 100000; i_cer++ ) {
+
+      //   inform about progress
+      
+      if (!( i_cer %1000) )
+	{
+	  cout << i_cer << endl ; 
+	  sprintf ( datname, "%d", fNumEvents ) ; 
+	  
+	  fDirNum->RemoveEntry(1) ; 
+	  fDirNum->AddEntry(datname,1) ; 	    
+	  fDirNum->MapSubwindows() ; 
+	  fDirNum->Layout() ;  
+	}
+      
+      
+      //   create the file names 
+      
+      sprintf ( cername, "%s/cer%06d", fInputPath, i_cer ) ; 
+      sprintf ( datname, "%s/dat%06d", fInputPath, i_cer ) ; 
+      
+      //   try to open the files
+      
+      cerfile.open( cername );
+    
+      if ( cerfile.bad() ) { 
+
+	fNumEvents = i_cer -1 ;
+	
 	sprintf ( datname, "%d", fNumEvents ) ; 
 	
@@ -344,51 +531,46 @@
 	fDirNum->MapSubwindows() ; 
 	fDirNum->Layout() ;  
+	
+	break ; 
       }
-
-    
-    //   create the file names 
-    
-    sprintf ( cername, "%s/cer%06d", fInputPath, i_cer ) ; 
-    sprintf ( datname, "%s/dat%06d", fInputPath, i_cer ) ; 
-    
-    //   try to open the files
-        
-    cerfile.open( cername );
-    
-    if ( cerfile.bad() ) { 
-
-      fNumEvents = i_cer -1 ;
-      
-      sprintf ( datname, "%d", fNumEvents ) ; 
-
-      fDirNum->RemoveEntry(1) ; 
-      fDirNum->AddEntry(datname,1) ; 	    
-      fDirNum->MapSubwindows() ; 
-      fDirNum->Layout() ;  
-      
-      break ; 
+      
+      Event.read( cerfile );
+
+      //
+      //   fill Ntuple
+      // 
+      
+      fNtup->Fill( Event.get_primary() ,
+		   Event.get_energy() , 
+		   Event.get_coreX(), 
+		   Event.get_coreY(), 
+		   Event.get_theta(),
+		   Event.get_phi(), 
+		   Event.get_firstInt() ) ;  
+
+ 
+      cerfile.close();
+    
     }
-    
-    Event.read( cerfile );
-
-    //
-    //   fill Ntuple
-    // 
-    
-    fNtup->Fill( Event.get_primary() ,
-		 Event.get_energy() , 
-		 Event.get_coreX(), 
-		 Event.get_coreY() ) ;  
-
- 
-    cerfile.close();
-    
+
+    //
+    //  write Ntuple to the file
+    //
+    fNtup->Write() ; 
+
+    //
+    //  write the root file
+    //
+    hfile->Write();
+    
+    delete hfile ; 
   }
 
+
   //
   //    set some value of this class
   //
-  sprintf ( fNtupPath, "%s", fInputPath) ;  
-
+  sprintf ( fNtupPath, "%s", fInputPath) ;
+  
   return (kTRUE) ; 
 }
@@ -408,6 +590,6 @@
   void *np = NULL ;      // null pointer
 
-  TCanvas *canvas =  fCanvasRun->GetCanvas();   
- 
+  TCanvas *canvas =  fCanvasRun->GetCanvas();
+   
   // Process events generated by the buttons in the frame.
 
@@ -473,36 +655,34 @@
 	break;
 
+      case M_BUTTON_PRINT: 
+	canvas->Print("simone.ps") ; 
+	//	gSystem->Exec("lpr simone.ps") ; 
+	gSystem->Exec("rm -f simone.ps") ; 
+	break; 
+
       case M_BUTTON_PARTID: 
-	if ( CheckNtup() )  
-	  {
-	    fNtup->Draw("PartID") ; 
-	    canvas->Modified() ; 
-	    canvas->Update() ; 
-	  }
-	else  
-	  printf("No Ntuple exist!!\n"); 
+	DrawRunParam("PartID") ; 
+	break ; 
+
+      case M_BUTTON_ENERGY: 
+	DrawRunParam("log10(Energy)") ; 
 	break; 
 
-      case M_BUTTON_ENERGY: 
-	if ( CheckNtup() )  
-	  {
-	    fNtup->Draw("Energy") ; 
-	    canvas->Modified() ; 
-	    canvas->Update() ; 
-	  }
-	else  
-	  printf("No Ntuple exist!!\n"); 
+      case M_BUTTON_CORE: 
+	DrawRunParam("CoreY:CoreX") ; 
 	break; 
-
-      case M_BUTTON_CORE: 
-	if ( CheckNtup() )  
-	  {
-	    fNtup->Draw("CoreY:CoreX") ; 
-	    canvas->Modified() ; 
-	    canvas->Update() ; 
-	  }
-	else  
-	  printf("No Ntuple exist!!\n"); 
+	
+      case M_BUTTON_THETA: 
+	DrawRunParam("Theta") ; 
 	break; 
+
+      case M_BUTTON_PHI:
+	DrawRunParam("Phi") ; 
+	break;  
+
+      case M_BUTTON_FIRSTINT: 
+	DrawRunParam("FirstInt") ; 
+	break; 	
+
 
       case M_CTRL_EXIT:
Index: trunk/MagicSoft/Simulation/Corsika/GuiSimone/MainFrameSimone.hxx
===================================================================
--- trunk/MagicSoft/Simulation/Corsika/GuiSimone/MainFrameSimone.hxx	(revision 416)
+++ trunk/MagicSoft/Simulation/Corsika/GuiSimone/MainFrameSimone.hxx	(revision 423)
@@ -11,4 +11,5 @@
 #include <TRootEmbeddedCanvas.h>
 #include <TNtuple.h>
+#include <TFile.h>
 #include <TCanvas.h>
 
@@ -24,9 +25,20 @@
   M_BUTTON_SELECT,
 
-  M_BUTTON_PLOT, 
+  M_BUTTON_PRINT, 
   M_BUTTON_PARTID, 
   M_BUTTON_ENERGY, 
   M_BUTTON_CORE,
+  M_BUTTON_THETA,
+  M_BUTTON_PHI,
+  M_BUTTON_FIRSTINT,
 
+  M_BUTTON_PREV, 
+  M_BUTTON_NEXT, 
+
+  M_BUTTON_WAVELEN, 
+  M_BUTTON_POSIT, 
+  M_BUTTON_HEIGHT, 
+  M_BUTTON_TIME, 
+  M_BUTTON_DIRE, 
 
   M_CTRL_EXIT, 
@@ -49,5 +61,6 @@
   TGCompositeFrame  *fFrame ; 
   TGTab             *fTab ; 
-  TGCompositeFrame  *fTabF1, *fTabF2, *fTabF3 ; 
+  TGCompositeFrame  *fTabF1, *fTabF2, *fTabF3, *fTabF4 ; 
+
   TGCompositeFrame  *fTabF1a, *fTabF1b ; 
   TGTextButton      *fSelectButton ; 
@@ -56,11 +69,22 @@
   TGFileContainer   *fFileCont ; 
   TGListView        *fFileView ;
+
   TGCompositeFrame  *fTabF2a, *fTabF2b, *fTabF2c ; 
   TGLabel           *fLabelInput, *fLabelNumEvts ;
   TGListBox         *fDir2, *fDirNum ; 
-  TGTextButton      *fButtonPlot ; 
+  TGTextButton      *fButtonPrint ; 
   TRootEmbeddedCanvas    *fCanvasRun ; 
   TGTextButton      *fButtonPartID, *fButtonEnergy, *fButtonCore ; 
-  
+  TGTextButton      *fButtonTheta, *fButtonPhi, *fButtonFirst ; 
+
+  TGCompositeFrame  *fTabF3a, *fTabF3b, *fTabF3c ; 
+  TGLabel           *fLabel3, *fLabel4 ;
+  TGListBox         *fDir3, *fDirEvtNb ;
+  TRootEmbeddedCanvas    *fCanvasEvt ;  
+  TGTextButton      *fButtonPrev, *fButtonNext ; 
+  TGTextButton      *fButtonWave, *fButtonPosit ; 
+  TGTextButton      *fButtonHeight, *fButtonTime, *fButtonDire ; 
+
+
   TGTextButton      *fButton1 ;
   TGTextButton      *fButton2 ;
@@ -79,4 +103,5 @@
 
   Bool_t CerFileExist(Char_t *dir) ; 
+  Bool_t DrawRunParam(Char_t *paraName) ; 
   Bool_t CheckNtup() ; 
   Bool_t ReadDataToNtup() ; 
Index: trunk/MagicSoft/Simulation/Corsika/GuiSimone/Makefile
===================================================================
--- trunk/MagicSoft/Simulation/Corsika/GuiSimone/Makefile	(revision 416)
+++ trunk/MagicSoft/Simulation/Corsika/GuiSimone/Makefile	(revision 423)
@@ -19,7 +19,7 @@
 #
 # $RCSfile: Makefile,v $
-# $Revision: 1.2 $
+# $Revision: 1.3 $
 # $Author: harald $ 
-# $Date: 2000-07-06 11:31:05 $
+# $Date: 2000-07-15 09:31:07 $
 #
 ##################################################################
@@ -90,5 +90,5 @@
 	simone.o      
 
-PROGRAM=simone
+PROGRAM=guisimone
 
 ############################################################
@@ -168,36 +168,89 @@
 ../../Detector/include-CORSIKA/COREventHeader.o: ../../Detector/include-CORSIKA/COREventHeader.hxx
 ../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/stdlib.h
-../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/standards.h
-../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/getopt.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/features.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/sys/cdefs.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/gnu/stubs.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/lib/gcc-lib/i486-linux/2.7.2.3/include/stddef.h
 ../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/sys/types.h
-../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/mach/machine/vm_types.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/bits/types.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/time.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/endian.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/bits/endian.h
 ../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/sys/select.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/bits/select.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/bits/sigset.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/sys/sysmacros.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/alloca.h
 ../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/math.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/bits/huge_val.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/bits/mathdef.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/include/bits/mathcalls.h
+../../Detector/include-CORSIKA/COREventHeader.o: /usr/lib/gcc-lib/i486-linux/2.7.2.3/include/float.h
 ../../Detector/include-CORSIKA/CORParticle.o: ../../Detector/include-CORSIKA/CORParticle.hxx
 ../../Detector/include-CORSIKA/CORParticle.o: /usr/include/stdlib.h
-../../Detector/include-CORSIKA/CORParticle.o: /usr/include/standards.h
-../../Detector/include-CORSIKA/CORParticle.o: /usr/include/getopt.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/include/features.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/include/sys/cdefs.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/include/gnu/stubs.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/lib/gcc-lib/i486-linux/2.7.2.3/include/stddef.h
 ../../Detector/include-CORSIKA/CORParticle.o: /usr/include/sys/types.h
-../../Detector/include-CORSIKA/CORParticle.o: /usr/include/mach/machine/vm_types.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/include/bits/types.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/include/time.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/include/endian.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/include/bits/endian.h
 ../../Detector/include-CORSIKA/CORParticle.o: /usr/include/sys/select.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/include/bits/select.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/include/bits/sigset.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/include/sys/sysmacros.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/include/alloca.h
 ../../Detector/include-CORSIKA/CORParticle.o: /usr/include/math.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/include/bits/huge_val.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/include/bits/mathdef.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/include/bits/mathcalls.h
+../../Detector/include-CORSIKA/CORParticle.o: /usr/lib/gcc-lib/i486-linux/2.7.2.3/include/float.h
 ../../Detector/include-CORSIKA/CORStatfile.o: ../../Detector/include-CORSIKA/CORStatfile.hxx
 ../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/stdlib.h
-../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/standards.h
-../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/getopt.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/features.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/sys/cdefs.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/gnu/stubs.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/lib/gcc-lib/i486-linux/2.7.2.3/include/stddef.h
 ../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/sys/types.h
-../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/mach/machine/vm_types.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/bits/types.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/time.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/endian.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/bits/endian.h
 ../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/sys/select.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/bits/select.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/bits/sigset.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/sys/sysmacros.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/alloca.h
 ../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/math.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/bits/huge_val.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/bits/mathdef.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/include/bits/mathcalls.h
+../../Detector/include-CORSIKA/CORStatfile.o: /usr/lib/gcc-lib/i486-linux/2.7.2.3/include/float.h
 MainFrameSimone.o: MainFrameSimone.hxx
 MainFrameSimone.o: ../../Detector/include-CORSIKA/COREventHeader.hxx
-MainFrameSimone.o: /usr/include/stdlib.h /usr/include/standards.h
-MainFrameSimone.o: /usr/include/getopt.h /usr/include/sys/types.h
-MainFrameSimone.o: /usr/include/mach/machine/vm_types.h
-MainFrameSimone.o: /usr/include/sys/select.h /usr/include/math.h
-simone.o: /usr/include/stdlib.h /usr/include/standards.h
-simone.o: /usr/include/getopt.h /usr/include/sys/types.h
-simone.o: /usr/include/mach/machine/vm_types.h /usr/include/sys/select.h
+MainFrameSimone.o: /usr/include/stdlib.h /usr/include/features.h
+MainFrameSimone.o: /usr/include/sys/cdefs.h /usr/include/gnu/stubs.h
+MainFrameSimone.o: /usr/lib/gcc-lib/i486-linux/2.7.2.3/include/stddef.h
+MainFrameSimone.o: /usr/include/sys/types.h /usr/include/bits/types.h
+MainFrameSimone.o: /usr/include/time.h /usr/include/endian.h
+MainFrameSimone.o: /usr/include/bits/endian.h /usr/include/sys/select.h
+MainFrameSimone.o: /usr/include/bits/select.h /usr/include/bits/sigset.h
+MainFrameSimone.o: /usr/include/sys/sysmacros.h /usr/include/alloca.h
+MainFrameSimone.o: /usr/include/math.h /usr/include/bits/huge_val.h
+MainFrameSimone.o: /usr/include/bits/mathdef.h /usr/include/bits/mathcalls.h
+MainFrameSimone.o: /usr/lib/gcc-lib/i486-linux/2.7.2.3/include/float.h
+simone.o: /usr/include/stdlib.h /usr/include/features.h
+simone.o: /usr/include/sys/cdefs.h /usr/include/gnu/stubs.h
+simone.o: /usr/lib/gcc-lib/i486-linux/2.7.2.3/include/stddef.h
+simone.o: /usr/include/sys/types.h /usr/include/bits/types.h
+simone.o: /usr/include/time.h /usr/include/endian.h
+simone.o: /usr/include/bits/endian.h /usr/include/sys/select.h
+simone.o: /usr/include/bits/select.h /usr/include/bits/sigset.h
+simone.o: /usr/include/sys/sysmacros.h /usr/include/alloca.h
 simone.o: MainFrameSimone.hxx
 simone.o: ../../Detector/include-CORSIKA/COREventHeader.hxx
-simone.o: /usr/include/math.h
+simone.o: /usr/include/math.h /usr/include/bits/huge_val.h
+simone.o: /usr/include/bits/mathdef.h /usr/include/bits/mathcalls.h
+simone.o: /usr/lib/gcc-lib/i486-linux/2.7.2.3/include/float.h